/*
	File:			Jitter16.cc

	Function:		Program to calculate sample positions for a 4 x 4
					jittered grid.

	Author(s):		Andrew Willmott

	Copyright:		Copyright (c) 1997, Andrew Willmott

	Notes:			

*/

#include "VLd.h"
#include <stdlib.h>
#include <iomanip.h>

// Magic squares!

Int square1[4][4] = {
	15,  8,  5,  2,
	 4,  3, 14,  9,
	10, 13,  0,  7,
	 1,  6, 11, 12
	};

Int square2[4][4] = {
	10, 7, 12, 1,
	13, 0, 11, 6,
	3, 14, 5, 8,
	4, 9, 2, 15
	};

Void CheckSquare(Int square[4][4])
// Is it really magic?
{
	Int i, j;
	Int csum, rsum;
	
	for (i = 0; i < 4; i++)
	{
		rsum = 0;
		csum = 0;
		for (j = 0; j < 4; j++)
		{
			rsum += square[i][j];
			csum += square[j][i];
		}
		cout << rsum << ", " << csum << endl;
	}
}

Void GenCoords(Int square[4][4], Int numArrays, Double jitterAmt, char *name)
// range of jitterAmt: 0-1
{
	Int i, j, k, m;
	Double x, y;
	
	cout << "static Double " << name << "[" << numArrays
			<< "][16][2] =" << endl <<"{" << endl;
	
	for (m = 0; m < numArrays; m++)
	{
		for (k = 0; k < 16; k++)
			for (i = 0; i < 4; i++)
				for (j = 0; j < 4; j++)
					if (square[i][j] == k)
					{
						x = 1 / 8.0 + i / 4.0 + (drand48() - 0.5) * jitterAmt * 1.0 / 4.0;
						y = 1 / 8.0 + j / 4.0 + (drand48() - 0.5) * jitterAmt * 1.0 / 4.0;
						
						if (k % 4 == 0)
							cout << "    ";
						
						cout << setprecision(3) << x << ", " << setprecision(3) << y;
						
						if (k % 4 != 3)
							cout << ", ";	
						else if (k / 4 == 3 && m == numArrays - 1)
							cout << endl;
						else
							cout << "," << endl;
					}
	}
	
	cout << "};" << endl << endl;
}

Void GenTriCoords(Int square[4][4], Int numArrays, Double jitterAmt, char *name)
{
	Int i, j, k, m;
	Double x, y, s, t;
	
	cout << "static Double " << name << "[" << numArrays
			<< "][16][2] =" << endl <<"{" << endl;
	
	for (m = 0; m < numArrays; m++)
	{
		for (k = 0; k < 16; k++)
			for (i = 0; i < 4; i++)
				for (j = 0; j < 4; j++)
					if (square[i][j] == k)
					{
						x = 1 / 8.0 + i / 4.0 + (drand48() - 0.5) * jitterAmt * 1.0 / 4.0;
						y = 1 / 8.0 + j / 4.0 + (drand48() - 0.5) * jitterAmt * 1.0 / 4.0;
						
						y = sqrt(y);
						s = x * y;
						t = 1 - y;
						
						if (k % 4 == 0)
							cout << "    ";
						
						cout << setprecision(3) << s << ", " << setprecision(3) << t;
						
						if (k % 4 != 3)
							cout << ", ";	
						else if (k / 4 == 3 && m == numArrays - 1)
							cout << endl;
						else
							cout << "," << endl;
					}
	}

	cout << "};" << endl << endl;
}

int main(int argc, char *argv[])
{
	Matd	matrix, matrix2;
	Double	factor;
	Double	jitterAmt = 0.8;
	Int		numArrays = 7;
	
	//CheckSquare(square1);	
	//CheckSquare(square2);	

	cout << "// This file was automatically generated by " << argv[0] << endl
		 << endl;
		 
	cout << "static Int kNumMSArrays = " << numArrays << ";" << endl << endl;

	GenCoords(square1, numArrays, jitterAmt, "tSource4x4");
	GenCoords(square2, numArrays, jitterAmt, "tDest4x4");
	GenTriCoords(square1, numArrays, jitterAmt, "tTriSource4x4");
	GenTriCoords(square2, numArrays, jitterAmt, "tTriDest4x4");
	
	return(0);
}
